## halibut 0.9

=== Makefile ===
# Halibut master makefile

# Currently depends on gcc, because:
#  - the dependency tracking uses -MD in order to avoid needing an
#    explicit `make depend' step
#  - the definition of CFLAGS includes the gcc-specific flag
#    `-Wall'
#
# Currently depends on GNU make, because:
#  - the Makefile uses GNU ifdef / ifndef commands and GNU make `%'
#    pattern rules

ifdef RELEASE
ifndef VERSION
VERSION := $(RELEASE)
endif
else
CFLAGS += -g
endif

ifeq (x$(VERSION)y,xy)
RELDIR := halibut
else
RELDIR := halibut-$(VERSION)
endif

# `make' from top level will build in directory `build'
# `make BUILDDIR=foo' from top level will build in directory foo
ifndef REALBUILD
ifndef BUILDDIR
ifdef TEST
BUILDDIR := test
else
BUILDDIR := build
endif
endif

all:
	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
	@make -C $(BUILDDIR) -f ../Makefile REALBUILD=yes

spotless: topclean
	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
	@make -C $(BUILDDIR) -f ../Makefile spotless REALBUILD=yes

clean: topclean
	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
	@make -C $(BUILDDIR) -f ../Makefile clean REALBUILD=yes

# Remove Halibut output files in the source directory (may
# have been created by running, for example, `build/halibut
# inputs/test.but').
topclean:
	rm -f *.html output.* *.tar.gz

# Make a release archive. If $(VERSION) is specified, this will
# also contain a `manifest' file which will be used to decide the
# version number automatically.
release:
	find . -name CVS -prune -o -name build -prune -o -name reltmp -prune \
	       -o -type d -exec mkdir -p reltmp/$(RELDIR)/{} \;
	find . -name CVS -prune -o -name build -prune -o -name reltmp -prune \
	       -o -name '*.orig' -prune -o -name '*.rej' -prune \
	       -o -name '*.txt' -prune -o -name '*.html' -prune \
	       -o -name '*.1' -prune -o -name '.cvsignore' -prune \
	       -o -name '*.gz' -prune -o -name '.[^.]*' -prune \
	       -o -type f -exec ln -s $(PWD)/{} reltmp/$(RELDIR)/{} \;
	if test "x$(VERSION)y" != "xy"; then                            \
	    (cd reltmp/$(RELDIR);                                       \
	     find . -name '*.[ch]' -exec md5sum {} \;                   \
	    ) > reltmp/$(RELDIR)/manifest;                              \
	    echo "-DVERSION=\"$(VERSION)\"" > reltmp/$(RELDIR)/version; \
	fi
	tar chzvCf reltmp - $(RELDIR) > $(RELDIR).tar.gz
	rm -rf reltmp

else

# The `real' makefile part.

CFLAGS += -Wall -W

ifdef TEST
CFLAGS += -DLOGALLOC
LIBS += -lefence
endif

ifndef VER
ifdef VERSION
VER := $(VERSION)
endif
endif
ifdef VER
VDEF = -DVERSION=\"$(VER)\"
else
VDEF = `(cd $(SRC); md5sum -c manifest && cat version)`
endif

SRC := ../

MODULES := main malloc ustring error help licence version misc tree234
MODULES += input keywords contents index style biblio
MODULES += bk_text bk_xhtml bk_whlp bk_man
MODULES += winhelp

OBJECTS := $(addsuffix .o,$(MODULES))
DEPS := $(addsuffix .d,$(MODULES))

halibut: $(OBJECTS)
	$(CC) $(LFLAGS) -o halibut $(OBJECTS) $(LIBS)

%.o: $(SRC)%.c
	$(CC) $(CFLAGS) -MD -c $<

version.o: FORCE
	$(CC) $(VDEF) -MD -c $(SRC)version.c

spotless:: clean
	rm -f *.d

clean::
	rm -f *.o halibut core

FORCE: # phony target to force version.o to be rebuilt every time

-include $(DEPS)

endif

=== doc/Makefile ===
CHAPTERS := $(SITE) blurb intro running input output licence manpage index

INPUTS = $(patsubst %,%.but,$(CHAPTERS))

HALIBUT = ../build/halibut

all: Contents.html halibut.1

Contents.html: $(INPUTS) $(HALIBUT)
	$(HALIBUT) --text=halibut.txt --html $(INPUTS)

halibut.1: manpage.but
	$(HALIBUT) --man=halibut.1 manpage.but

clean:
	rm -f *.html *.txt *.hlp *.cnt *.1

## halibut 0.9+cvs20040804

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,11 @@
 # Currently depends on GNU make, because:
 #  - the Makefile uses GNU ifdef / ifndef commands and GNU make `%'
 #    pattern rules
+
+prefix=/usr/local
+exec_prefix=$(prefix)
+bindir=$(exec_prefix)/bin
+INSTALL=install -c
 
 ifdef RELEASE
 ifndef VERSION
@@ -35,9 +40,9 @@
 endif
 endif
 
-all:
+all install:
 	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
-	@make -C $(BUILDDIR) -f ../Makefile REALBUILD=yes
+	@make -C $(BUILDDIR) -f ../Makefile $@ REALBUILD=yes
 
 spotless: topclean
 	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
@@ -71,7 +76,7 @@
 	    ) > reltmp/$(RELDIR)/manifest;                              \
 	    echo "-DVERSION=\"$(VERSION)\"" > reltmp/$(RELDIR)/version; \
 	fi
-	tar chzvCf reltmp - $(RELDIR) > $(RELDIR).tar.gz
+	tar chzvoCf reltmp - $(RELDIR) > $(RELDIR).tar.gz
 	rm -rf reltmp
 
 else
@@ -96,14 +101,24 @@
 VDEF = `(cd $(SRC); md5sum -c manifest && cat version)`
 endif
 
+all: halibut
+
 SRC := ../
+
+LIBCHARSET_SRCDIR = $(SRC)charset/
+LIBCHARSET_OBJDIR = ./#
+LIBCHARSET_OBJPFX = cs-#
+LIBCHARSET_GENPFX = charset-#
+MD = -MD
+CFLAGS += -I$(LIBCHARSET_SRCDIR) -I$(LIBCHARSET_OBJDIR)
+include $(LIBCHARSET_SRCDIR)Makefile
 
 MODULES := main malloc ustring error help licence version misc tree234
 MODULES += input keywords contents index style biblio
-MODULES += bk_text bk_xhtml bk_whlp bk_man
-MODULES += winhelp
+MODULES += bk_text bk_html bk_whlp bk_man bk_info bk_paper bk_ps bk_pdf
+MODULES += winhelp psdata wcwidth
 
-OBJECTS := $(addsuffix .o,$(MODULES))
+OBJECTS := $(addsuffix .o,$(MODULES)) $(LIBCHARSET_OBJS)
 DEPS := $(addsuffix .d,$(MODULES))
 
 halibut: $(OBJECTS)
@@ -121,6 +136,10 @@
 clean::
 	rm -f *.o halibut core
 
+install:
+	$(INSTALL) -m 755 halibut $(bindir)/halibut
+	$(MAKE) -C ../doc install prefix="$(prefix)" INSTALL="$(INSTALL)"
+
 FORCE: # phony target to force version.o to be rebuilt every time
 
 -include $(DEPS)

=== charset/Makefile ===
# -*- make -*-
#
# Makefile for libcharset.

# This Makefile should be sufficient to build libcharset and its
# demo application all on its own. However, it's also a valid
# Makefile _fragment_ which can be linked in to another program
# Makefile to allow libcharset to be built directly into its
# binary.

# To include this as part of another Makefile, you need to:
#
#  - Define $(LIBCHARSET_SRCDIR) to be a directory prefix (i.e.
#    probably ending in a slash) which allows access to the
#    libcharset source files.
#
#  - Define $(LIBCHARSET_OBJDIR) to be a directory prefix (i.e.
#    probably ending in a slash) which allows access to the
#    directory where the libcharset object files need to be put.
#
#  - Define $(LIBCHARSET_OBJPFX) to be a filename prefix to be
#    applied to the libcharset object files (in case, for example,
#    the file names clash with those of the main application, and
#    you need to call them cs-*.o to resolve the clash).
#
#  - Define $(LIBCHARSET_GENPFX) to be a prefix to be added to
#    targets such as `all' and `clean'. (Mostly the point of this
#    is to get those targets out of the way for the Makefile
#    fragment including us.)
#
#  - If you need your compiler to use the -MD flag, define $(MD) to
#    be `-MD'.
#
# This Makefile fragment will then define rules for building each
# object file, and will in turn define $(LIBCHARSET_OBJS) to be
# what you need to add to your link line.

$(LIBCHARSET_GENPFX)all: \
	$(LIBCHARSET_OBJDIR)libcharset.a \
	$(LIBCHARSET_OBJDIR)convcs

$(LIBCHARSET_OBJDIR)convcs: $(LIBCHARSET_OBJDIR)libcharset.a
	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)convcs \
		$(LIBCHARSET_SRCDIR)test.c \
		$(LIBCHARSET_OBJDIR)libcharset.a

LIBCHARSET_OBJS = \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5enc.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5set.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cp949.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)fromucs.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)gb2312.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)hz.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)istate.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0208.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0212.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)ksx1001.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)locale.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)localenc.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)macenc.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)mimeenc.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)sbcs.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)sbcsdat.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)shiftjis.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)slookup.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)superset.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)toucs.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf16.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf7.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf8.o \
	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)xenc.o \
	# end of list

$(LIBCHARSET_OBJDIR)libcharset.a: $(LIBCHARSET_OBJS)
	ar rcs $@ $(LIBCHARSET_OBJS)

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5enc.o: \
	$(LIBCHARSET_SRCDIR)big5enc.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5set.o: \
	$(LIBCHARSET_SRCDIR)big5set.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cp949.o: \
	$(LIBCHARSET_SRCDIR)cp949.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o: \
	$(LIBCHARSET_SRCDIR)euc.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)fromucs.o: \
	$(LIBCHARSET_SRCDIR)fromucs.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)gb2312.o: \
	$(LIBCHARSET_SRCDIR)gb2312.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)hz.o: \
	$(LIBCHARSET_SRCDIR)hz.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o: \
	$(LIBCHARSET_SRCDIR)iso2022s.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)istate.o: \
	$(LIBCHARSET_SRCDIR)istate.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0208.o: \
	$(LIBCHARSET_SRCDIR)jisx0208.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0212.o: \
	$(LIBCHARSET_SRCDIR)jisx0212.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)ksx1001.o: \
	$(LIBCHARSET_SRCDIR)ksx1001.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)locale.o: \
	$(LIBCHARSET_SRCDIR)locale.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)localenc.o: \
	$(LIBCHARSET_SRCDIR)localenc.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)macenc.o: \
	$(LIBCHARSET_SRCDIR)macenc.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)mimeenc.o: \
	$(LIBCHARSET_SRCDIR)mimeenc.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)sbcs.o: \
	$(LIBCHARSET_SRCDIR)sbcs.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)shiftjis.o: \
	$(LIBCHARSET_SRCDIR)shiftjis.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)slookup.o: \
	$(LIBCHARSET_SRCDIR)slookup.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)superset.o: \
	$(LIBCHARSET_SRCDIR)superset.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)toucs.o: \
	$(LIBCHARSET_SRCDIR)toucs.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf16.o: \
	$(LIBCHARSET_SRCDIR)utf16.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf7.o: \
	$(LIBCHARSET_SRCDIR)utf7.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf8.o: \
	$(LIBCHARSET_SRCDIR)utf8.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)xenc.o: \
	$(LIBCHARSET_SRCDIR)xenc.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

# This object file is special, because its source file is itself
# generated - and therefore goes in the object directory.

$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)sbcsdat.o: \
	$(LIBCHARSET_OBJDIR)sbcsdat.c
	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

$(LIBCHARSET_OBJDIR)sbcsdat.c: \
	$(LIBCHARSET_SRCDIR)sbcs.dat \
	$(LIBCHARSET_SRCDIR)sbcsgen.pl
	perl $(LIBCHARSET_SRCDIR)sbcsgen.pl \
		$(LIBCHARSET_SRCDIR)sbcs.dat $@

$(LIBCHARSET_GENPFX)clean:
	rm -f $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)*.o \
		$(LIBCHARSET_OBJDIR)libcharset.a \
		$(LIBCHARSET_OBJDIR)sbcsdat.c \
		$(LIBCHARSET_OBJDIR)convcs

## halibut 0.9+svn20050729

=== Makefile ===
--- 
+++ 
@@ -9,11 +9,14 @@
 # Currently depends on GNU make, because:
 #  - the Makefile uses GNU ifdef / ifndef commands and GNU make `%'
 #    pattern rules
+#  - we use .PHONY
 
 prefix=/usr/local
 exec_prefix=$(prefix)
 bindir=$(exec_prefix)/bin
 INSTALL=install -c
+
+.PHONY: all install clean spotless topclean release
 
 ifdef RELEASE
 ifndef VERSION
@@ -42,15 +45,15 @@
 
 all install:
 	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
-	@make -C $(BUILDDIR) -f ../Makefile $@ REALBUILD=yes
+	@$(MAKE) -C $(BUILDDIR) -f ../Makefile $@ REALBUILD=yes
 
 spotless: topclean
 	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
-	@make -C $(BUILDDIR) -f ../Makefile spotless REALBUILD=yes
+	@$(MAKE) -C $(BUILDDIR) -f ../Makefile spotless REALBUILD=yes
 
 clean: topclean
 	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
-	@make -C $(BUILDDIR) -f ../Makefile clean REALBUILD=yes
+	@$(MAKE) -C $(BUILDDIR) -f ../Makefile clean REALBUILD=yes
 
 # Remove Halibut output files in the source directory (may
 # have been created by running, for example, `build/halibut
@@ -61,23 +64,8 @@
 # Make a release archive. If $(VERSION) is specified, this will
 # also contain a `manifest' file which will be used to decide the
 # version number automatically.
-release:
-	find . -name CVS -prune -o -name build -prune -o -name reltmp -prune \
-	       -o -type d -exec mkdir -p reltmp/$(RELDIR)/{} \;
-	find . -name CVS -prune -o -name build -prune -o -name reltmp -prune \
-	       -o -name '*.orig' -prune -o -name '*.rej' -prune \
-	       -o -name '*.txt' -prune -o -name '*.html' -prune \
-	       -o -name '*.1' -prune -o -name '.cvsignore' -prune \
-	       -o -name '*.gz' -prune -o -name '.[^.]*' -prune \
-	       -o -type f -exec ln -s $(PWD)/{} reltmp/$(RELDIR)/{} \;
-	if test "x$(VERSION)y" != "xy"; then                            \
-	    (cd reltmp/$(RELDIR);                                       \
-	     find . -name '*.[ch]' -exec md5sum {} \;                   \
-	    ) > reltmp/$(RELDIR)/manifest;                              \
-	    echo "-DVERSION=\"$(VERSION)\"" > reltmp/$(RELDIR)/version; \
-	fi
-	tar chzvoCf reltmp - $(RELDIR) > $(RELDIR).tar.gz
-	rm -rf reltmp
+release: release.sh
+	./release.sh $(RELDIR) $(VERSION)
 
 else
 
@@ -105,7 +93,11 @@
 
 SRC := ../
 
+ifeq ($(shell test -d $(SRC)charset && echo yes),yes)
 LIBCHARSET_SRCDIR = $(SRC)charset/
+else
+LIBCHARSET_SRCDIR = $(SRC)../charset/
+endif
 LIBCHARSET_OBJDIR = ./#
 LIBCHARSET_OBJPFX = cs-#
 LIBCHARSET_GENPFX = charset-#

=== charset/Makefile ===
--- 
+++ 
@@ -37,11 +37,19 @@
 
 $(LIBCHARSET_GENPFX)all: \
 	$(LIBCHARSET_OBJDIR)libcharset.a \
-	$(LIBCHARSET_OBJDIR)convcs
-
-$(LIBCHARSET_OBJDIR)convcs: $(LIBCHARSET_OBJDIR)libcharset.a
+	$(LIBCHARSET_OBJDIR)convcs \
+	$(LIBCHARSET_OBJDIR)cstable
+
+$(LIBCHARSET_OBJDIR)convcs: $(LIBCHARSET_SRCDIR)test.c \
+	$(LIBCHARSET_OBJDIR)libcharset.a
 	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)convcs \
 		$(LIBCHARSET_SRCDIR)test.c \
+		$(LIBCHARSET_OBJDIR)libcharset.a
+
+$(LIBCHARSET_OBJDIR)cstable: $(LIBCHARSET_SRCDIR)cstable.c \
+	$(LIBCHARSET_OBJDIR)libcharset.a
+	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)cstable \
+		$(LIBCHARSET_SRCDIR)cstable.c \
 		$(LIBCHARSET_OBJDIR)libcharset.a
 
 LIBCHARSET_OBJS = \
@@ -105,7 +113,8 @@
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o: \
-	$(LIBCHARSET_SRCDIR)iso2022s.c
+	$(LIBCHARSET_SRCDIR)iso2022s.c \
+	$(LIBCHARSET_OBJDIR)sbcsdat.h
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)istate.o: \
@@ -183,14 +192,17 @@
 	$(LIBCHARSET_OBJDIR)sbcsdat.c
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
 
-$(LIBCHARSET_OBJDIR)sbcsdat.c: \
+$(LIBCHARSET_OBJDIR)sbcsdat.c $(LIBCHARSET_OBJDIR)sbcsdat.h: \
 	$(LIBCHARSET_SRCDIR)sbcs.dat \
 	$(LIBCHARSET_SRCDIR)sbcsgen.pl
 	perl $(LIBCHARSET_SRCDIR)sbcsgen.pl \
-		$(LIBCHARSET_SRCDIR)sbcs.dat $@
+		$(LIBCHARSET_SRCDIR)sbcs.dat \
+		$(LIBCHARSET_OBJDIR)sbcsdat.c \
+		$(LIBCHARSET_OBJDIR)sbcsdat.h
 
 $(LIBCHARSET_GENPFX)clean:
 	rm -f $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)*.o \
 		$(LIBCHARSET_OBJDIR)libcharset.a \
 		$(LIBCHARSET_OBJDIR)sbcsdat.c \
+		$(LIBCHARSET_OBJDIR)sbcsdat.h \
 		$(LIBCHARSET_OBJDIR)convcs

=== doc/Makefile ===
mandir=$(prefix)/man
man1dir=$(mandir)/man1

CHAPTERS := $(SITE) blurb intro running input output licence manpage index

INPUTS = $(patsubst %,%.but,$(CHAPTERS))

HALIBUT = ../build/halibut

all: index.html halibut.1

index.html: $(INPUTS) $(HALIBUT)
	$(HALIBUT) --text=halibut.txt --html --info=halibut.info \
		--ps=halibut.ps --pdf=halibut.pdf $(INPUTS)

halibut.1: manpage.but
	$(HALIBUT) --man=halibut.1 manpage.but

install:
	$(INSTALL) -m 644 halibut.1 $(man1dir)/halibut.1

clean:
	rm -f *.html *.txt *.hlp *.cnt *.1 *.info* *.ps *.pdf

## halibut 1.0

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 
 # The `real' makefile part.
 
-CFLAGS += -Wall -W
+CFLAGS += -Wall -W -ansi -pedantic
 
 ifdef TEST
 CFLAGS += -DLOGALLOC
@@ -86,7 +86,7 @@
 ifdef VER
 VDEF = -DVERSION=\"$(VER)\"
 else
-VDEF = `(cd $(SRC); md5sum -c manifest && cat version)`
+VDEF = `(cd $(SRC); md5sum -c manifest >& /dev/null && cat version)`
 endif
 
 all: halibut
@@ -106,9 +106,9 @@
 include $(LIBCHARSET_SRCDIR)Makefile
 
 MODULES := main malloc ustring error help licence version misc tree234
-MODULES += input keywords contents index style biblio
+MODULES += input in_afm in_pf keywords contents index biblio
 MODULES += bk_text bk_html bk_whlp bk_man bk_info bk_paper bk_ps bk_pdf
-MODULES += winhelp psdata wcwidth
+MODULES += winhelp deflate psdata wcwidth
 
 OBJECTS := $(addsuffix .o,$(MODULES)) $(LIBCHARSET_OBJS)
 DEPS := $(addsuffix .d,$(MODULES))

=== charset/Makefile ===
--- 
+++ 
@@ -55,11 +55,13 @@
 LIBCHARSET_OBJS = \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5enc.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5set.o \
+	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cns11643.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cp949.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)fromucs.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)gb2312.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)hz.o \
+	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)istate.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0208.o \
@@ -92,6 +94,10 @@
 	$(LIBCHARSET_SRCDIR)big5set.c
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
 
+$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cns11643.o: \
+	$(LIBCHARSET_SRCDIR)cns11643.c
+	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cp949.o: \
 	$(LIBCHARSET_SRCDIR)cp949.c
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
@@ -110,6 +116,11 @@
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)hz.o: \
 	$(LIBCHARSET_SRCDIR)hz.c
+	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+
+$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022.o: \
+	$(LIBCHARSET_SRCDIR)iso2022.c \
+	$(LIBCHARSET_OBJDIR)sbcsdat.h
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o: \

## halibut 1.0%2Bsvn20090906

=== charset/Makefile ===
--- 
+++ 
@@ -57,6 +57,7 @@
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5set.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cns11643.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cp949.o \
+	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)emacsenc.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)fromucs.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)gb2312.o \
@@ -102,6 +103,10 @@
 	$(LIBCHARSET_SRCDIR)cp949.c
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
 
+$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)emacsenc.o: \
+	$(LIBCHARSET_SRCDIR)emacsenc.c
+	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o: \
 	$(LIBCHARSET_SRCDIR)euc.c
 	$(CC) $(CFLAGS) $(MD) -c -o $@ $<

## halibut 1.0%2bsvn20090906

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@

buildflags := $(shell dpkg-buildflags --export=configure)

DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

override_dh_auto_build:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(buildflags) dh_auto_build
	$(MAKE) -C doc
else
	$(buildflags) dh_auto_build -- CC=$(DEB_HOST_GNU_TYPE)-gcc
	$(buildflags) $(MAKE) BUILDDIR=build-native
	$(MAKE) -C doc HALIBUT=../build-native/halibut
endif

override_dh_auto_clean:
	$(MAKE) -C doc clean
	dh_auto_clean
	rm -rf build build-native

# Not worth the hassle; we do this ourselves.
override_dh_auto_install:
	:

## halibut 1.0%2bsvn20090906-8

=== debian/control ===
Source: halibut
Section: text
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 3.9.5
Build-Depends: dpkg-dev, debhelper (>= 7.0.50~)
Homepage: http://www.chiark.greenend.org.uk/~sgtatham/halibut.html
Vcs-Git: git://anonscm.debian.org/users/cjwatson/halibut.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/cjwatson/halibut.git

Package: halibut
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Enhances: enscript, vim
Description: yet another free document preparation system
 This is yet another text formatting system, intended primarily for writing
 software documentation. It accepts a single source format and outputs any
 or all of text, HTML, Windows Help, man pages, GNU info, PostScript, or
 PDF. It has comprehensive indexing and cross-referencing support, and
 generates hyperlinks within output documents wherever possible. It supports
 Unicode, with the ability to fall back to an alternative representation
 when Unicode output is not available.

## halibut 1.0%2bsvn20090906-9

=== debian/changelog ===
halibut (1.0+svn20090906-9) unstable; urgency=medium

  * Switch to git; add Vcs-* fields.
  * Policy version 3.9.5: no changes required.

 -- Colin Watson <cjwatson@debian.org>  Sun, 16 Feb 2014 20:33:46 +0000

halibut (1.0+svn20090906-8) unstable; urgency=medium

  * Switch to git; add Vcs-* fields.
  * Policy version 3.9.5: no changes required.

 -- Colin Watson <cjwatson@debian.org>  Sun, 16 Feb 2014 20:33:46 +0000

halibut (1.0+svn20090906-7) unstable; urgency=low

  * Mark halibut Multi-Arch: foreign.

 -- Colin Watson <cjwatson@debian.org>  Fri, 23 Nov 2012 01:35:07 +0000

halibut (1.0+svn20090906-6) unstable; urgency=low

  * The upstream build system doesn't honour CPPFLAGS or LDFLAGS, but only
    CFLAGS and LFLAGS.  Adjust our use of dpkg-buildflags accordingly.

 -- Colin Watson <cjwatson@debian.org>  Fri, 22 Jun 2012 12:46:50 +0100

halibut (1.0+svn20090906-5) unstable; urgency=low

  * Use dpkg-buildflags to set default compiler flags.

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Sep 2011 23:23:56 +0100

halibut (1.0+svn20090906-4) unstable; urgency=low

  * Add cross-compiling support.

 -- Colin Watson <cjwatson@debian.org>  Fri, 16 Sep 2011 11:11:37 +0100

halibut (1.0+svn20090906-3) unstable; urgency=low

  * Convert to source format 3.0 (quilt).
  * Move homepage from Description to Homepage field.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Dec 2010 18:06:38 +0000

halibut (1.0+svn20090906-2) unstable; urgency=low

  * Register with vim-addon-manager, and add a README.Debian documenting how
    to switch Vim syntax highlighting on (closes: #464821).

 -- Colin Watson <cjwatson@debian.org>  Sat, 20 Feb 2010 01:32:08 +0000

halibut (1.0+svn20090906-1) unstable; urgency=low

  * New upstream snapshot.
    - More portable attempt to get a literal U+0027 than r8321, pinched from
      pod2man.
    - Revise r8309 to use \- rather than - when trying to emit a literal
      U+002D (closes: #496063).
  * Upgrade to debhelper 7.
  * Drop leading "Applications/" from doc-base Section field, per Lintian.

 -- Colin Watson <cjwatson@debian.org>  Mon, 07 Sep 2009 01:09:30 +0100

halibut (1.0-1) unstable; urgency=low

  * New upstream release (closes: #409219).
  * Use dh_install and dh_installman.
  * Update to menu structure from menu 2.1.35.
  * Policy version 3.7.2. No changes required.
  * Fix bashism in upstream Makefile.

 -- Colin Watson <cjwatson@debian.org>  Wed, 14 Nov 2007 09:44:30 +0000

halibut (0.9+svn20050729-1) unstable; urgency=low

  * New upstream snapshot.
    - Remove erroneous .UC from generated man pages (closes: #320333).
  * Upgrade to debhelper v4.
  * Register halibut documentation with doc-base.
  * Policy version 3.6.2. No changes required.

 -- Colin Watson <cjwatson@debian.org>  Sun,  7 Aug 2005 15:52:37 +0100

halibut (0.9+svn20050412-1) unstable; urgency=low

  * New upstream snapshot.
    - Fix segfault on empty paragraph (closes: #304204).
  * Install vim syntax file (':setf halibut' to use); Enhances: vim.
  * Enhances: enscript.
  * Avoid building halibut and the HTML documentation twice during the
    build.

 -- Colin Watson <cjwatson@debian.org>  Tue, 12 Apr 2005 13:31:24 +0100

halibut (0.9+svn20050310-1) unstable; urgency=low

  * New upstream snapshot.
  * Install highlighting mode for GNU enscript.
  * Update debian/copyright (new year).

 -- Colin Watson <cjwatson@debian.org>  Sun, 10 Apr 2005 11:53:15 +0100

halibut (0.9+cvs20040804-1) unstable; urgency=low

  * New upstream snapshot.
    - Fix sizeof/lenof confusion in contents.c that caused random segfaults
      (closes: #262863).

 -- Colin Watson <cjwatson@debian.org>  Wed,  4 Aug 2004 17:42:00 +0100

halibut (0.9+cvs20040801-1) unstable; urgency=low

  * New upstream snapshot.
    - Add GNU info, PostScript, and PDF output backends.
    - Fix Windows Help hash calculation on 64-bit systems (closes: #259504).
  * Add a debian/watch file.
  * Install Halibut info documentation.
  * Update debian/copyright.
  * Update package description to mention new output formats.

 -- Colin Watson <cjwatson@debian.org>  Sun,  1 Aug 2004 18:08:50 +0100

halibut (0.9-1) unstable; urgency=low

  * Initial release.

 -- Colin Watson <cjwatson@debian.org>  Mon,  7 Jun 2004 21:26:35 +0100

## halibut 1.0%2bsvn20090906-10

=== debian/changelog ===
halibut (1.0+svn20090906-10) unstable; urgency=medium

  * Switch to git; add Vcs-* fields.
  * Policy version 3.9.5: no changes required.

 -- Colin Watson <cjwatson@debian.org>  Sun, 16 Feb 2014 20:33:46 +0000

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,10 @@
 %:
 	dh $@
 
-buildflags := $(shell dpkg-buildflags --export=configure)
+CFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS += $(shell dpkg-buildflags --get CFLAGS)
+LFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+buildflags := CFLAGS="$(CFLAGS)" LFLAGS="$(LFLAGS)"
 
 DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
@@ -25,3 +28,6 @@
 # Not worth the hassle; we do this ourselves.
 override_dh_auto_install:
 	:
+
+override_dh_installinfo:
+	echo skip dh_installinfo

## halibut 1.0+svn20090906

=== Makefile ===
--- 
+++ 
@@ -86,7 +86,7 @@
 ifdef VER
 VDEF = -DVERSION=\"$(VER)\"
 else
-VDEF = `(cd $(SRC); md5sum -c manifest >& /dev/null && cat version)`
+VDEF = `(cd $(SRC); md5sum -c manifest >/dev/null 2>&1 && cat version)`
 endif
 
 all: halibut
@@ -106,7 +106,7 @@
 include $(LIBCHARSET_SRCDIR)Makefile
 
 MODULES := main malloc ustring error help licence version misc tree234
-MODULES += input in_afm in_pf keywords contents index biblio
+MODULES += input in_afm in_pf in_sfnt keywords contents index biblio
 MODULES += bk_text bk_html bk_whlp bk_man bk_info bk_paper bk_ps bk_pdf
 MODULES += winhelp deflate psdata wcwidth

=== doc/Makefile ===
--- 
+++ 
@@ -20,4 +20,8 @@
 	$(INSTALL) -m 644 halibut.1 $(man1dir)/halibut.1
 
 clean:
-	rm -f *.html *.txt *.hlp *.cnt *.1 *.info* *.ps *.pdf
+	rm -f *.html *.txt *.hlp *.cnt *.1 *.info* *.ps *.pdf *.hh* *.chm
+
+chm: halibut.hhp
+halibut.hhp: $(INPUTS) $(HALIBUT) chm.but
+	$(HALIBUT) --html $(INPUTS) chm.but

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.9.5
-Build-Depends: dpkg-dev, debhelper (>= 7.0.50~)
+Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 7.0.50~)
 Homepage: http://www.chiark.greenend.org.uk/~sgtatham/halibut.html
 Vcs-Git: git://anonscm.debian.org/users/cjwatson/halibut.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/cjwatson/halibut.git

=== debian/rules ===
--- 
+++ 
@@ -28,6 +28,3 @@
 # Not worth the hassle; we do this ourselves.
 override_dh_auto_install:
 	:
-
-override_dh_installinfo:
-	echo skip dh_installinfo

=== debian/watch ===
version=2
http://www.chiark.greenend.org.uk/~sgtatham/halibut/halibut-(.*)\.tar\.gz

## halibut 1.1

=== Makefile ===
--- 
+++ 
@@ -61,9 +61,7 @@
 topclean:
 	rm -f *.html output.* *.tar.gz
 
-# Make a release archive. If $(VERSION) is specified, this will
-# also contain a `manifest' file which will be used to decide the
-# version number automatically.
+# Makef a release archive.
 release: release.sh
 	./release.sh $(RELDIR) $(VERSION)
 
@@ -76,17 +74,6 @@
 ifdef TEST
 CFLAGS += -DLOGALLOC
 LIBS += -lefence
-endif
-
-ifndef VER
-ifdef VERSION
-VER := $(VERSION)
-endif
-endif
-ifdef VER
-VDEF = -DVERSION=\"$(VER)\"
-else
-VDEF = `(cd $(SRC); md5sum -c manifest >/dev/null 2>&1 && cat version)`
 endif
 
 all: halibut

=== charset/Makefile ===
--- 
+++ 
@@ -38,7 +38,8 @@
 $(LIBCHARSET_GENPFX)all: \
 	$(LIBCHARSET_OBJDIR)libcharset.a \
 	$(LIBCHARSET_OBJDIR)convcs \
-	$(LIBCHARSET_OBJDIR)cstable
+	$(LIBCHARSET_OBJDIR)cstable \
+	$(LIBCHARSET_OBJDIR)confuse
 
 $(LIBCHARSET_OBJDIR)convcs: $(LIBCHARSET_SRCDIR)test.c \
 	$(LIBCHARSET_OBJDIR)libcharset.a
@@ -50,6 +51,12 @@
 	$(LIBCHARSET_OBJDIR)libcharset.a
 	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)cstable \
 		$(LIBCHARSET_SRCDIR)cstable.c \
+		$(LIBCHARSET_OBJDIR)libcharset.a
+
+$(LIBCHARSET_OBJDIR)confuse: $(LIBCHARSET_SRCDIR)confuse.c \
+	$(LIBCHARSET_OBJDIR)libcharset.a
+	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)confuse \
+		$(LIBCHARSET_SRCDIR)confuse.c \
 		$(LIBCHARSET_OBJDIR)libcharset.a
 
 LIBCHARSET_OBJS = \

=== debian/changelog ===
halibut (1.1-4) unstable; urgency=medium

  * Convert debian/copyright to copyright-format 1.0.

 -- Colin Watson <cjwatson@debian.org>  Sat, 16 Jan 2016 22:39:07 +0000

halibut (1.1-3) unstable; urgency=medium

  * Upgrade to debhelper v9.
  * Build with large file support.

 -- Colin Watson <cjwatson@debian.org>  Mon, 04 Jan 2016 13:04:23 +0000

halibut (1.1-2) unstable; urgency=medium

  * Implement SOURCE_DATE_EPOCH for reproducible builds.
  * Build Halibut's own documentation with LC_ALL=C.UTF-8 TZ=UTC to avoid
    reproducibility problems.

 -- Colin Watson <cjwatson@debian.org>  Fri, 06 Nov 2015 16:28:26 +0000

halibut (1.1-1) unstable; urgency=medium

  * New upstream release (closes: #782031).

 -- Colin Watson <cjwatson@debian.org>  Fri, 21 Aug 2015 16:19:08 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: text
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
-Standards-Version: 3.9.5
-Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 7.0.50~)
+Standards-Version: 3.9.6
+Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9)
 Homepage: http://www.chiark.greenend.org.uk/~sgtatham/halibut.html
 Vcs-Git: git://anonscm.debian.org/users/cjwatson/halibut.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/cjwatson/halibut.git
+Vcs-Browser: http://anonscm.debian.org/cgit/users/cjwatson/halibut.git/
 
 Package: halibut
 Architecture: any

## halibut 1.2

=== Makefile ===
--- 
+++ 
@@ -76,7 +76,9 @@
 LIBS += -lefence
 endif
 
-all: halibut
+EXE =#
+
+all: halibut$(EXE)
 
 SRC := ../
 
@@ -91,17 +93,18 @@
 MD = -MD
 CFLAGS += -I$(LIBCHARSET_SRCDIR) -I$(LIBCHARSET_OBJDIR)
 include $(LIBCHARSET_SRCDIR)Makefile
+CC_LINK = $(CC) -o $@
 
 MODULES := main malloc ustring error help licence version misc tree234
 MODULES += input in_afm in_pf in_sfnt keywords contents index biblio
 MODULES += bk_text bk_html bk_whlp bk_man bk_info bk_paper bk_ps bk_pdf
-MODULES += winhelp deflate psdata wcwidth
+MODULES += winhelp winchm deflate lzx lz77 huffman psdata wcwidth
 
 OBJECTS := $(addsuffix .o,$(MODULES)) $(LIBCHARSET_OBJS)
 DEPS := $(addsuffix .d,$(MODULES))
 
-halibut: $(OBJECTS)
-	$(CC) $(LFLAGS) -o halibut $(OBJECTS) $(LIBS)
+halibut$(EXE): $(OBJECTS)
+	$(CC_LINK) $(LFLAGS) $(OBJECTS) $(LIBS)
 
 %.o: $(SRC)%.c
 	$(CC) $(CFLAGS) -MD -c $<
@@ -116,6 +119,7 @@
 	rm -f *.o halibut core
 
 install:
+	mkdir -p $(prefix) $(bindir)
 	$(INSTALL) -m 755 halibut $(bindir)/halibut
 	$(MAKE) -C ../doc install prefix="$(prefix)" INSTALL="$(INSTALL)"

=== charset/Makefile ===
--- 
+++ 
@@ -39,17 +39,20 @@
 	$(LIBCHARSET_OBJDIR)libcharset.a \
 	$(LIBCHARSET_OBJDIR)convcs \
 	$(LIBCHARSET_OBJDIR)cstable \
-	$(LIBCHARSET_OBJDIR)confuse
-
-$(LIBCHARSET_OBJDIR)convcs: $(LIBCHARSET_SRCDIR)test.c \
+	$(LIBCHARSET_OBJDIR)confuse \
+	$(LIBCHARSET_OBJDIR)csshow
+
+$(LIBCHARSET_OBJDIR)convcs: $(LIBCHARSET_SRCDIR)convcs.c \
 	$(LIBCHARSET_OBJDIR)libcharset.a
 	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)convcs \
-		$(LIBCHARSET_SRCDIR)test.c \
+		$(LIBCHARSET_SRCDIR)convcs.c \
 		$(LIBCHARSET_OBJDIR)libcharset.a
 
 $(LIBCHARSET_OBJDIR)cstable: $(LIBCHARSET_SRCDIR)cstable.c \
-	$(LIBCHARSET_OBJDIR)libcharset.a
-	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)cstable \
+	$(LIBCHARSET_OBJDIR)libcharset.a \
+	$(LIBCHARSET_OBJDIR)sbcsdat.c
+	$(CC) $(CFLAGS) -I $(LIBCHARSET_OBJDIR). \
+		-o $(LIBCHARSET_OBJDIR)cstable \
 		$(LIBCHARSET_SRCDIR)cstable.c \
 		$(LIBCHARSET_OBJDIR)libcharset.a
 
@@ -57,6 +60,12 @@
 	$(LIBCHARSET_OBJDIR)libcharset.a
 	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)confuse \
 		$(LIBCHARSET_SRCDIR)confuse.c \
+		$(LIBCHARSET_OBJDIR)libcharset.a
+
+$(LIBCHARSET_OBJDIR)csshow: $(LIBCHARSET_SRCDIR)csshow.c \
+	$(LIBCHARSET_OBJDIR)libcharset.a
+	$(CC) $(CFLAGS) -o $(LIBCHARSET_OBJDIR)csshow \
+		$(LIBCHARSET_SRCDIR)csshow.c \
 		$(LIBCHARSET_OBJDIR)libcharset.a
 
 LIBCHARSET_OBJS = \
@@ -68,6 +77,7 @@
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)fromucs.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)gb2312.o \
+	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)htmlcs.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)hz.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022.o \
 	$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o \
@@ -96,132 +106,143 @@
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5enc.o: \
 	$(LIBCHARSET_SRCDIR)big5enc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)big5set.o: \
 	$(LIBCHARSET_SRCDIR)big5set.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cns11643.o: \
 	$(LIBCHARSET_SRCDIR)cns11643.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)cp949.o: \
 	$(LIBCHARSET_SRCDIR)cp949.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)emacsenc.o: \
 	$(LIBCHARSET_SRCDIR)emacsenc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)euc.o: \
 	$(LIBCHARSET_SRCDIR)euc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)fromucs.o: \
 	$(LIBCHARSET_SRCDIR)fromucs.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)gb2312.o: \
 	$(LIBCHARSET_SRCDIR)gb2312.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
+
+$(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)htmlcs.o: \
+	$(LIBCHARSET_SRCDIR)htmlcs.c
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)hz.o: \
 	$(LIBCHARSET_SRCDIR)hz.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022.o: \
 	$(LIBCHARSET_SRCDIR)iso2022.c \
 	$(LIBCHARSET_OBJDIR)sbcsdat.h
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -I $(LIBCHARSET_OBJDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)iso2022s.o: \
 	$(LIBCHARSET_SRCDIR)iso2022s.c \
 	$(LIBCHARSET_OBJDIR)sbcsdat.h
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -I $(LIBCHARSET_OBJDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)istate.o: \
 	$(LIBCHARSET_SRCDIR)istate.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0208.o: \
 	$(LIBCHARSET_SRCDIR)jisx0208.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)jisx0212.o: \
 	$(LIBCHARSET_SRCDIR)jisx0212.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)ksx1001.o: \
 	$(LIBCHARSET_SRCDIR)ksx1001.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)locale.o: \
 	$(LIBCHARSET_SRCDIR)locale.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)localenc.o: \
 	$(LIBCHARSET_SRCDIR)localenc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)macenc.o: \
 	$(LIBCHARSET_SRCDIR)macenc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)mimeenc.o: \
 	$(LIBCHARSET_SRCDIR)mimeenc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)sbcs.o: \
 	$(LIBCHARSET_SRCDIR)sbcs.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)shiftjis.o: \
 	$(LIBCHARSET_SRCDIR)shiftjis.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)slookup.o: \
-	$(LIBCHARSET_SRCDIR)slookup.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(LIBCHARSET_SRCDIR)slookup.c \
+	$(LIBCHARSET_OBJDIR)sbcsdat.c
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -I $(LIBCHARSET_OBJDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)superset.o: \
 	$(LIBCHARSET_SRCDIR)superset.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)toucs.o: \
 	$(LIBCHARSET_SRCDIR)toucs.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf16.o: \
 	$(LIBCHARSET_SRCDIR)utf16.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf7.o: \
 	$(LIBCHARSET_SRCDIR)utf7.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)utf8.o: \
 	$(LIBCHARSET_SRCDIR)utf8.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)xenc.o: \
 	$(LIBCHARSET_SRCDIR)xenc.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
 
 # This object file is special, because its source file is itself
 # generated - and therefore goes in the object directory.
 
 $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)sbcsdat.o: \
 	$(LIBCHARSET_OBJDIR)sbcsdat.c
-	$(CC) $(CFLAGS) $(MD) -c -o $@ $<
-
-$(LIBCHARSET_OBJDIR)sbcsdat.c $(LIBCHARSET_OBJDIR)sbcsdat.h: \
+	$(CC) $(CFLAGS) $(MD) -I $(LIBCHARSET_SRCDIR). -c -o $@ $<
+
+$(LIBCHARSET_OBJDIR)sbcsdat.c: \
 	$(LIBCHARSET_SRCDIR)sbcs.dat \
 	$(LIBCHARSET_SRCDIR)sbcsgen.pl
 	perl $(LIBCHARSET_SRCDIR)sbcsgen.pl \
 		$(LIBCHARSET_SRCDIR)sbcs.dat \
-		$(LIBCHARSET_OBJDIR)sbcsdat.c \
-		$(LIBCHARSET_OBJDIR)sbcsdat.h
+		--source=$(LIBCHARSET_OBJDIR)sbcsdat.c
+
+$(LIBCHARSET_OBJDIR)sbcsdat.h: \
+	$(LIBCHARSET_SRCDIR)sbcs.dat \
+	$(LIBCHARSET_SRCDIR)sbcsgen.pl
+	perl $(LIBCHARSET_SRCDIR)sbcsgen.pl \
+		$(LIBCHARSET_SRCDIR)sbcs.dat \
+		--header=$(LIBCHARSET_OBJDIR)sbcsdat.h
 
 $(LIBCHARSET_GENPFX)clean:
 	rm -f $(LIBCHARSET_OBJDIR)$(LIBCHARSET_OBJPFX)*.o \

=== doc/Makefile ===
mandir=$(prefix)/man
man1dir=$(mandir)/man1

CHAPTERS := $(SITE) blurb intro running input output licence manpage index

INPUTS = $(patsubst %,%.but,$(CHAPTERS))

HALIBUT = ../build/halibut

all: index.html halibut.1

index.html: $(INPUTS) $(HALIBUT)
	$(HALIBUT) --text=halibut.txt --html --info=halibut.info \
		--ps=halibut.ps --pdf=halibut.pdf --chm=halibut.chm $(INPUTS)

halibut.1: manpage.but
	$(HALIBUT) --man=halibut.1 manpage.but

install:
	mkdir -p $(man1dir)
	$(INSTALL) -m 644 halibut.1 $(man1dir)/halibut.1

clean:
	rm -f *.html *.txt *.hlp *.cnt *.1 *.info* *.ps *.pdf *.chm

=== debian/changelog ===
halibut (1.2-1) unstable; urgency=medium

  * New upstream release.
  * Use HTTPS for Vcs-* URLs.
  * Update Homepage, debian/copyright Source, and debian/watch to use HTTPS.
  * Adjust debian/watch to cope with an extra subdirectory.

 -- Colin Watson <cjwatson@debian.org>  Sun, 18 Jun 2017 11:30:08 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.9.6
 Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 9)
-Homepage: http://www.chiark.greenend.org.uk/~sgtatham/halibut.html
-Vcs-Git: git://anonscm.debian.org/users/cjwatson/halibut.git
-Vcs-Browser: http://anonscm.debian.org/cgit/users/cjwatson/halibut.git/
+Homepage: https://www.chiark.greenend.org.uk/~sgtatham/halibut.html
+Vcs-Git: https://anonscm.debian.org/git/users/cjwatson/halibut.git
+Vcs-Browser: https://anonscm.debian.org/cgit/users/cjwatson/halibut.git/
 
 Package: halibut
 Architecture: any

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := -D_FILE_OFFSET_BITS=64
include /usr/share/dpkg/buildflags.mk
buildflags := CFLAGS="$(CPPFLAGS) $(CFLAGS)" LFLAGS="$(LDFLAGS)"

unexport TEST

DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

override_dh_auto_build:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(buildflags) dh_auto_build
	LC_ALL=C.UTF-8 TZ=UTC $(MAKE) -C doc
else
	$(buildflags) dh_auto_build -- CC=$(DEB_HOST_GNU_TYPE)-gcc
	$(buildflags) $(MAKE) BUILDDIR=build-native
	LC_ALL=C.UTF-8 TZ=UTC $(MAKE) -C doc HALIBUT=../build-native/halibut
endif

override_dh_auto_clean:
	$(MAKE) -C doc clean
	dh_auto_clean
	rm -rf build build-native

# Not worth the hassle; we do this ourselves.
override_dh_auto_install:
	:

=== debian/watch ===
version=3
https://www.chiark.greenend.org.uk/~sgtatham/halibut/ (?:.*/)?halibut-(.*)\.tar\.gz
